﻿Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports Bt
Imports Bt.ScanLib
'Imports KDST3000.BtScanLib
Imports BTClientLib
Imports System.IO
Imports System.Reflection
Imports BtScan2

Public Class frm3005
    Inherits System.Windows.Forms.Form
    Private btScanLib As BtScanLib
    Private scanHandler As Boolean = False
    'Private dbClient As BtrieveDbClient
    Private tmpStr As List(Of Dictionary(Of String, String))
    Private affected_rows As Integer


#Region " Windows tH[€ fUCiลถฌณ๊ฝR[h "

    Public Sub New()
        MyBase.New()

        ' ฑฬฤัoตอ Windows tH[€ fUCiล•K—vลทB
        InitializeComponent()

        ' InitializeComponent() ฤัoตฬใษ๚ป๐’วมตทB

    End Sub

    ' Form อAR“|[l“g๊——ษใ—๐ภsท้ฝ฿ษ dispose ๐I[o[ChตทB
    'Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    '    If disposing Then
    '        If Not (components Is Nothing) Then
    '            components.Dispose()
    '        End If
    '    End If
    '    MyBase.Dispose(disposing)
    'End Sub

    ' Windows tH[€ fUCiล•K—vลทB
    'Private components As System.ComponentModel.IContainer

    '  : ศบฬvV[WอAWindows tH[€ fUCiล•K—vลทB
    'Windows tH[€ fUCi๐gมฤ•ฯXตฤญพณขB  
    ' R[h GfB^๐gมฤ•ฯXตศขลญพณขB
    'Friend WithEvents WarpCtrl1 As WarpControl.WarpCtrl
    'Friend WithEvents WarpHWBcr1 As WarpControl.WarpHWBcr
    'Friend WithEvents WarpBox1 As WarpControl.WarpBox
    'Friend WithEvents wfKey As WarpControl.WarpField
    'Friend WithEvents WarpFrame1 As WarpControl.WarpFrame
    'Friend WithEvents wfName As WarpControl.WarpField

    '<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    '    Me.WarpFrame1 = New WarpControl.WarpFrame()
    '    Me.wfKey = New WarpControl.WarpField()
    '    Me.WarpBox1 = New WarpControl.WarpBox()
    '    Me.wfName = New WarpControl.WarpField()
    '    Me.WarpHWBcr1 = New WarpControl.WarpHWBcr()
    '    Me.WarpFrame1.SuspendLayout()
    '    Me.SuspendLayout()
    '    '
    '    'WarpFrame1
    '    '
    '    Me.WarpFrame1.Controls.Add(Me.wfKey)
    '    Me.WarpFrame1.Controls.Add(Me.WarpBox1)
    '    Me.WarpFrame1.Controls.Add(Me.wfName)
    '    Me.WarpFrame1.Font = New System.Drawing.Font("MS UI Gothic", 9.0!)
    '    Me.WarpFrame1.Location = New System.Drawing.Point(0, 0)
    '    Me.WarpFrame1.Name = "WarpFrame1"
    '    Me.WarpFrame1.Size = New System.Drawing.Size(240, 296)
    '    Me.WarpFrame1.TabIndex = 1
    '    Me.WarpFrame1.Text = "WarpFrame1"
    '    Me.WarpFrame1.UseMacro = False
    '    Me.WarpFrame1.UseMacroFileName = ""
    '    '
    '    'wfKey
    '    '
    '    Me.wfKey.BcrFlag = True
    '    Me.wfKey.DecimalPointPosition = CType(0, Short)
    '    Me.wfKey.Font = New System.Drawing.Font("lr SVbN", 33.5!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel)
    '    Me.wfKey.Format = ""
    '    Me.wfKey.InputMode.Secret = True
    '    Me.wfKey.Length = CType(1, Short)
    '    Me.wfKey.Location = New System.Drawing.Point(204, 84)
    '    Me.wfKey.MacroBcr = ""
    '    Me.wfKey.MacroIn = ""
    '    Me.wfKey.MacroKey = ""
    '    Me.wfKey.MacroOut = ""
    '    Me.wfKey.Name = "wfKey"
    '    Me.wfKey.Size = New System.Drawing.Size(18, 36)
    '    Me.wfKey.TabIndex = CType(4, Short)
    '    '
    '    'WarpBox1
    '    '
    '    Me.WarpBox1.BoxType = WarpControl.BoxTypes.Box
    '    Me.WarpBox1.DrawMode = WarpControl.DrawModes.Paint
    '    Me.WarpBox1.Font = New System.Drawing.Font("lr SVbN", 33.5!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel)
    '    Me.WarpBox1.ForeColor = CType(15, Short)
    '    Me.WarpBox1.Image = "C:\H081-0005.jpg"
    '    Me.WarpBox1.Location = New System.Drawing.Point(0, 192)
    '    Me.WarpBox1.Name = "WarpBox1"
    '    Me.WarpBox1.Size = New System.Drawing.Size(240, 24)
    '    Me.WarpBox1.TabIndex = 3
    '    Me.WarpBox1.Text = "Echo System"
    '    '
    '    'wfName
    '    '
    '    Me.wfName.DecimalPointPosition = CType(0, Short)
    '    Me.wfName.Font = New System.Drawing.Font("lr SVbN", 22.5!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel)
    '    Me.wfName.FontSize = WarpControl.FontSizes.Small2
    '    Me.wfName.Format = ""
    '    Me.wfName.Length = CType(20, Short)
    '    Me.wfName.Location = New System.Drawing.Point(0, 216)
    '    Me.wfName.MacroBcr = ""
    '    Me.wfName.MacroIn = ""
    '    Me.wfName.MacroKey = ""
    '    Me.wfName.MacroOut = ""
    '    Me.wfName.Name = "wfName"
    '    Me.wfName.Size = New System.Drawing.Size(240, 24)
    '    Me.wfName.TabIndex = CType(2, Short)
    '    '
    '    'WarpHWBcr1
    '    '
    '    Me.WarpHWBcr1.Decode.Code39 = True
    '    Me.WarpHWBcr1.DiscreteFirstLen = CType(0, Short)
    '    Me.WarpHWBcr1.DiscreteSecondLen = CType(0, Short)
    '    Me.WarpHWBcr1.InterleavedFirstLen = CType(0, Short)
    '    Me.WarpHWBcr1.InterleavedSecondLen = CType(0, Short)
    '    '
    '    'frm3005
    '    '
    '    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
    '    Me.ClientSize = New System.Drawing.Size(240, 296)
    '    Me.Controls.Add(Me.WarpFrame1)
    '    Me.Font = New System.Drawing.Font("MS UI Gothic", 9.0!)
    '    Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
    '    Me.Name = "frm3005"
    '    Me.Text = "Form1"
    '    Me.WarpFrame1.ResumeLayout(False)
    '    Me.ResumeLayout(False)

    'End Sub

#End Region

    Public Enum M3005_STATUS As Integer
        INIT = 0
        MENUBACK = 1
        NOTJ = 2
        NOT7 = 3
        NOTEXIST = 4
        DONE = 5
    End Enum

    Public mint3005status As Integer

    Private Sub frm3005_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '// Case QVGA -> resolution to 1/2
        If System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width = 240 Then
            Call resolution.VGAtoQVGA(Me)
        End If

        Dim wstrImage As String
        Dim rtn As Integer

        Try

            mint3005status = M3005_STATUS.INIT

            ' t[€ฬI[v“
            'rtn = WarpFrame1.Open()
            'If (rtn <> 0) Then
            '    Err.Raise(vbObjectError + 1, gAppName, "WarpError")
            'End If

            'sSetImgFName(G_CONST_MID_H3005, WarpBox1)

            sDisp3005()
            ' tH[€EC“ ภs
            sMain()

            ' t[€ฬN[Y
            'rtn = WarpFrame1.Close()
            'If (rtn <> 0) Then
            '    Err.Raise(vbObjectError + 1, gAppName, "WarpError")
            'End If

            ' tH[€EN[Y
            'Me.Close()

            Exit Sub

        Catch ex As Exception
            gintStatus = LOCA_STATUS.QUIT
            sErrLog(gAppName, "frm3005_Load", ex.ToString)
            Me.Close()
        End Try

    End Sub

    Private Sub btScanLib_OnScan(ByVal result As String)
        Dim buf As String = result
        Dim rtn As Integer

        If (Not fCheckCode(buf)) Then
            sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
            fFnc_WrpMsg("E", G_CONST_MID_E3E05)
            Exit Sub
        End If

        '“—อ—
        rtn = fProcInput(buf)

        If rtn = 0 Then
            Select Case mint3005status
                Case M3005_STATUS.INIT

                    RemoveHandler btScanLib.OnScan, AddressOf btScanLib_OnScan
                    btScanLib.Disable()

                    gintStatus = LOCA_STATUS.LOCATION
                    Me.Close()
                    Exit Sub

                Case M3005_STATUS.MENUBACK          'HTCTRL.ExeName๐มตฤI—น
                    sFinishApp()
                    gintStatus = LOCA_STATUS.QUIT
                    Me.Close()
                    Exit Sub

                Case M3005_STATUS.NOT7              '7…ศOศฬลดืฐาฏพฐผ
                    sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
                    fFnc_WrpMsg("E", G_CONST_MID_E3E05)
                    Exit Sub
                Case M3005_STATUS.NOTJ              'JศOศฬลดืฐาฏพฐผ
                    sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
                    fFnc_WrpMsg("E", G_CONST_MID_E3E05)
                    Exit Sub
                Case M3005_STATUS.NOTEXIST          'Qฦรฐภษ–ณขฬลดืฐาฏพฐผ
                    sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
                    fFnc_WrpMsg("E", G_CONST_MID_E3E10)
                    Exit Sub
                Case M3005_STATUS.DONE              'ณํษQฦลซฝ
                    gintStatus = LOCA_STATUS.LOCATION
                    Me.Close()
                    Exit Sub
            End Select

        Else

            'f0.WarpCtrl1.MessageBox(G_CONST_EMT_DB, G_CONST_EM_DB, MWA_DB_WARNING, MWA_DB_OK)
            MessageBox.Show(G_CONST_EM_DB, G_CONST_EMT_DB, MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1)



        End If

                


    End Sub


    ' t[€EC“
    Public Sub sMain()

        'Dim WKey As Short
        'Dim buf As String
        'Dim rtn As Integer

        'Try

        '    ' t[€ฬ—๐ฑฑษLqตทB
        '    Do While (True)

        '        ' R[h“—อ
        '        WKey = WarpFrame1.Input(wfKey)

        '        If WKey = WKY_ENT Then

        '        ElseIf WKey = WKY_BCR Then

        '            'สฐบฐฤ“—อฬๆ“พ
        '            rtn = WarpHWBcr1.Get(buf)
        '            sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.OK)
        '            If (rtn <> 0) Then
        '                Err.Raise(vbObjectError + 1, gAppName, "WarpError")
        '            End If

        '            'มชฏธรจผฏฤ
        '            If (Not fCheckCode(buf)) Then
        '                sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
        '                fFnc_WrpMsg("E", G_CONST_MID_E3E05)

        '                Exit Do
        '            End If

        '            '“—อ—
        '            rtn = fProcInput(buf)

        '            If rtn = 0 Then
        '                Select Case mint3005status
        '                    Case M3005_STATUS.INIT
        '                        gintStatus = LOCA_STATUS.LOCATION

        '                    Case M3005_STATUS.MENUBACK          'HTCTRL.ExeName๐มตฤI—น
        '                        sFinishApp()
        '                        gintStatus = LOCA_STATUS.QUIT

        '                    Case M3005_STATUS.NOT7              '7…ศOศฬลดืฐาฏพฐผ
        '                        sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
        '                        fFnc_WrpMsg("E", G_CONST_MID_E3E05)

        '                    Case M3005_STATUS.NOTJ              'JศOศฬลดืฐาฏพฐผ
        '                        sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
        '                        fFnc_WrpMsg("E", G_CONST_MID_E3E05)

        '                    Case M3005_STATUS.NOTEXIST          'Qฦรฐภษ–ณขฬลดืฐาฏพฐผ
        '                        sBeepSound(modPublicHT.BEEP_TYPE.A, modPublicHT.BEEP_SELECTION.NG)
        '                        fFnc_WrpMsg("E", G_CONST_MID_E3E10)

        '                    Case M3005_STATUS.DONE              'ณํษQฦลซฝ
        '                        gintStatus = LOCA_STATUS.LOCATION

        '                End Select

        '            Else

        '                f0.WarpCtrl1.MessageBox(G_CONST_EMT_DB, G_CONST_EM_DB, MWA_DB_WARNING, MWA_DB_OK)

        '            End If
        '            Exit Do

        '        ElseIf WKey = WKY_F1 Then

        '        ElseIf WKey = WKY_F2 Then

        '        ElseIf WKey = WKY_ERROR Then

        '            f0.WarpCtrl1.MessageBox(G_CONST_EMT_WARP, G_CONST_EM_WARP, MWA_DB_WARNING, MWA_DB_OK)

        '        End If

        '    Loop

        '    Exit Sub

        'Catch ex As Exception
        '    sErrLog(gAppName, "sMain", ex.ToString)
        'End Try

    End Sub

    '/*
    '|| ึ”–ผFsDisp3005
    '|| T—v  F3005ๆ–ส•\ฆ
    '*/
    Private Sub sDisp3005()

        'wfName.Puts(gstrctKDHT.strUserName)
        'wfName.Puts("")

        wfName.Text = ""

    End Sub

    '/*
    '|| ึ”–ผFfProcInput
    '|| T—v  F“—อ—
    '*/
    Private Function fProcInput(ByVal pstrInput As String) As Integer

        Dim rtn As Integer
        Dim wstrEmplCode As String
        Dim wintCnt As Integer
        Dim wstrWhere As String
        Dim wstrKey(0) As String, wstrKeyValue(0) As String

        fProcInput = -1

        Try

            If RTrim(pstrInput) = "OCMENUBACK" Then             'OCMENUBACKศ็ฮ
                mint3005status = M3005_STATUS.MENUBACK
                fProcInput = 0
                Exit Function

            ElseIf pstrInput.StartsWith("J") Then        'ๆ“ชชJศ็ฮ
                rtn = pstrInput.Length
                If rtn <> 7 Then                    '7…ศOศ็ฮ
                    mint3005status = M3005_STATUS.NOT7
                    fProcInput = 0
                    Exit Function
                End If

            Else
                mint3005status = M3005_STATUS.NOTJ
                fProcInput = 0
                Exit Function

            End If

            wstrWhere = ""
            wstrWhere = "EmplCode = '" & wstrEmplCode & "'"

            tmpStr = dbClient.Query("SELECT * FROM " + G_CONST_TBL_PICSUSER + " WHERE " + wstrWhere)

            Dim values As Dictionary(Of String, String) = New Dictionary(Of String, String)

            If tmpStr.Count > 0 Then

                values = tmpStr(0)

                Dim result As String = Nothing
                If values.TryGetValue("EmplCode", result) Then
                    gstrctKDHT.strUserNo = result
                End If
                If values.TryGetValue("EmplName", result) Then
                    gstrctKDHT.strUserName = result
                End If

                wstrKey(0) = "HTNumber"
                'wstrKey(1) = "Country"
                'wstrKey(2) = "ExeName"
                wstrKeyValue(0) = gstrctKDHT.strHdNo
                'wstrKeyValue(1) = gstrctKDHT.strCountry
                'wstrKeyValue(2) = gstrctKDHT.strExeName

                affected_rows = dbClient.Execute("UPDATE " + G_CONST_TBL_HTCTRL + " SET EmplCode='" + gstrctKDHT.strUserNo + "' WHERE " + wstrKey(0) + "=" + wstrKeyValue(0))

                fProcInput = 0
                mint3005status = M3005_STATUS.DONE

            ElseIf tmpStr.Count = 0 Then
                mint3005status = M3005_STATUS.NOTEXIST
                fProcInput = 0
                Exit Function

            Else
                Exit Function
            End If
            fProcInput = 0

            Exit Function

        Catch ex As Exception
            'gintStatus = ALL_STATUS.QUIT
            sErrLog(gAppName, "fProcInput", ex.ToString)
        End Try




            '๕๐Jnตท
        '    wstrEmplCode = Mid(pstrInput, 2)
        '    wstrWhere = ""
        '    wstrWhere = "@EmplCode = " & wstrEmplCode

        '    wintCnt = gclsDB.fGetData(G_CONST_TBL_PICSUSER, G_CONST_KEY_PICSUSERKEY00, wstrWhere, "USER1")
        '    If wintCnt > 0 Then

        '        With gclsDB.Extended("USER1")
        '            gstrctKDHT.strUserNo = .Item("EmplCode")
        '            gstrctKDHT.strUserName = .Item("EmplName")

        '            gclsDB.Setcolumn = ("EmplCode")                 '“o^/XV‘ฮ—๑–ผ
        '            gclsDB.SetData = (gstrctKDHT.strUserNo)     '“o^/XVf[^

        '            wstrKey(0) = "HTNumber"
        '            wstrKeyValue(0) = gstrctKDHT.strHdNo

        '            If gclsDB.fUpdRecords(G_CONST_TBL_HTCTRL, G_CONST_KEY_HTCTRLKEY00, wstrKey, wstrKeyValue) = -1 Then
        '                BtLib.Transaction.Abort()

        '            End If

        '            fProcInput = 0
        '            mint3005status = M3005_STATUS.DONE

        '        End With

        '    ElseIf wintCnt = 0 Then
        '        mint3005status = M3005_STATUS.NOTEXIST
        '        fProcInput = 0
        '        gclsDB.fCloseRecord("USER1")
        '        Exit Function

        '    ElseIf wintCnt = -1 Then
        '        gclsDB.fCloseRecord("USER1")
        '        Exit Function

        '    End If

        '    gclsDB.fCloseRecord("USER1")
        '    fProcInput = 0
        '    Exit Function

        'Catch ex As Exception
        '    sErrLog(gAppName, "fProcInput", ex.ToString)
        'End Try

    End Function

    Private Sub frm3005_Activated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        ' Enable BTScanLib
        If Not scanHandler Then
            btScanLib = btScanLib.getInstance()
            AddHandler btScanLib.OnScan, AddressOf btScanLib_OnScan
            scanHandler = True
            btScanLib.Debug = False
            btScanLib.Enable()
        End If
    End Sub

    Private Sub frm3005_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode.ToString()
            Case "F1"
            Case "F2"
                gintStatus = LOCA_STATUS.QUIT
                Me.Close()
                Exit Sub
        End Select
    End Sub
End Class
